install.packages(c("rvest","dplyr")) # 安装指定包

library(rvest) # 网页爬取包
library(dplyr) # 管道函数操作包

num <- 0 # 为文本文档编号，预先设置“num”变量

for (number in c(1:500)){
  url <- sprintf("https://www.chinadaily.com.cn/china/59b8d010a3108c54ed7dfc23/page_%s.html",number) # 通过for循环和sprintf格式化输出实现翻页
  
  # 识别网页上每一条新闻的标题（“<h4>”），提取标题下的新闻超链接（“<a href="">”），并存储于变量“url_all”中
  url_all <- url %>% read_html(encoding = "UTF-8") %>% html_nodes("h4") %>% html_nodes("a") %>% html_attr("href")

  # 批量爬取存储于变量“url_all”中的新闻超链接，并将新闻内容存储于独立文本文档中
  for (url_2 in url_all){
      url_2 <- sprintf("https:%s",url_2) # 为超链接添加“https:”的标头
      content <- url_2 %>% read_html(encoding = "UTF-8") %>% html_nodes("p") %>% html_text() # 找到段落（paragraph）的标签“p”并提取新闻内容
      print(content) # 输出爬取内容
      num <- num + 1 # 为文本文档编号
      num_1 <- formatC(num, flag = '0', width = 3) # 为编号“Add Lead”，如将“1”转化为“001”
      fileout <- file(sprintf("CNNews%s.txt",num_1),"w") # 创建文本文档，并以如“CNNews001.txt”的形式命名
      write(content,fileout) # 将爬取内容写入文本文档
     }
}