import requests # 网页爬取库
from bs4 import BeautifulSoup # HTML、XML等架构分析库
import re # 正则表达式库

num=0 # 为文本文档编号，预先设置“num”变量

# 设置爬取函数，输入网址，返回网址HTML源码
def soup(url):
    r = requests.get(url)
    r.encoding="utf-8"
    demo = r.text
    soup = BeautifulSoup(demo, "html.parser")
    return soup

for number in range(1,501): # 循环翻页（1-500页）

    # 在一级网页上找到每条新闻的二级网页超链接
    url="https://www.chinadaily.com.cn/china/59b8d010a3108c54ed7dfc23/page_{}.html".format(number)
    page_1=soup(url)

    for e_1 in page_1.find_all("h4"): # 定位到每一条新闻的标题标签（“<h4>”）

        title=""
        meta=""
        content=""
        url_2=""

        for e_2 in e_1.find_all("a"):
            url_2="https:{}".format(str(e_2["href"])) # 找到每一条新闻对应的二级网页超链接（“<a href="">”）

            # 访问二级网页超链接
            page_2=soup(url_2)
            for e_3 in page_2.find_all("div", attrs={"class": "lft_art"}):

                # 爬取新闻标题并清洗
                for e_4 in e_3.find_all("h1"):
                    title=e_4.text
                    title=re.sub(r'\s+',' ',title)
                    title=str(title).strip()

                # 爬取新闻元数据并清洗
                for e_4 in e_3.find_all("div", attrs={"class": "info"}):
                    meta=e_4.text
                    meta=re.sub(r'\s+',' ',meta)
                    meta=str(meta).strip()

                # 爬取新闻具体内容并清洗
                for e_4 in e_3.find_all("div", attrs={"id": "Content"}):
                    for e_5 in e_4.find_all("p"):
                        content_1=e_5.text
                        content_1=re.sub(r'\s+', ' ', content_1)
                        content_1=str(content_1).strip()
                        content+=content_1

        # 以XML格式，格式化输出博主用户名、博文元数据和博文内容
        news="<seg>\n<title>{}</title>\n<meta>{}</meta>\n<content>{}</content>\n</seg>\n".format(title, meta,content)

        # 通过正则表达式搜索“现代化”的相应关键词，出现次数在3次及以上，则按照“CNTECH001.txt”的名称形式创建独立文本文档，并将爬取内容以XML格式存储于其中
        reg="tech|technology|technologies|technological|technique|techniques|technical"
        match=re.findall(reg,news.lower())
        if len(match)>2:
            num += 1
            num_1 = "{:0>3}".format(num)
            fileout = open("CNTECH{}.txt".format(num_1), "w", encoding="utf8")
            fileout.write(news)
            print(news)