install.packages(c("httr","rvest","dplyr","stringr")) # 安装指定包

# 请将R、Rstudio以及各类用到的包升级到最新版本

library(httr) # 网页爬取包（可携带“cookie”）
library(rvest) # 网页爬取包
library(dplyr) # 管道函数操作包
library(stringr) # 字符串处理包

num <- 0 # 为文本文档编号，预先设置“num”变量

for (number in c(1:50)){
  url <- sprintf("https://s.weibo.com/weibo?q=国乒&page=%s",number) # 通过for循环和sprintf格式化输出实现翻页
  
  # 携带"cookie"读取网页，找到该页面每一条微博的节点“<div class="content">”，并存储于向量“source”中
  source <- httr::GET(url, 
                      set_cookies("_s_tentry"="passport.weibo.com",
                                  "Apache"="4675218162863.373.1711463068403",
                                  "SINAGLOBAL"="4675218162863.373.1711463068403",
                                  "ULV"="1711463068431:1:1:1:4675218162863.373.1711463068403:",
                                  "XSRF-TOKEN"="JVpCjgdfDy4AijynlU5WUaUR",
                                  "ALF"="1714055090",
                                  "SUB"="_2A25LBqriDeRhGeFK41cT-S_PyzSIHXVofaIqrDV8PUJbkNANLVPikW1NQs831zU-ItMKokbN5U7qW_0QlA6cJunS",
                                  "SUBP"="0033WrSXqPxfM725Ws9jqgMF55529P9D9WF_-2QyRD6njCA5FcvA.mQZ5JpX5KzhUgL.FoMX1h-E1K20ehn2dJLoI0qLxKMLBKnL12zLxKqLBo5L1K2LxKnL1hnL1-eLxKML1-2L1hBLxK-LBo5L12qLxK-LB-BL1K5t",
                                  "WBPSESS"="mrmGZPu571k1faBDBsXvvVXQ5rH1vK6zpHOrJCcnrE2YcSxl476wciZVNduIpYCmdHyNcPqM1GRZazG7Ky4I0geeEjdLxT8BzHIDWpHKWcQB_c5Z9aBpUJvbvaxkLbmbHxYlmqOc3JDi3FdBaBglNQ==")) %>% 
    read_html(encoding = "UTF-8")  %>% 
    html_nodes("div[class=content]") # 提取每一条微博的节点“<div class="content">”，并存储于“source”中
  
  Sys.sleep(5) # 每爬取一页面后，休息5秒，已避免微博系统的反爬取
  
  # 遍历“source”中的每条微博，提取博主名称、元数据和博文
  for (web in source){
    
    # 爬取博主名称（““<div class="info">”），并基于“stringr”库清洗
    user <- web %>% html_nodes("div[class=info]") %>% html_nodes("div[style]") %>% html_text()
    user <- gsub("\\s+"," ",user) # 基于正则表达式将“\s+”删除
    user <- str_trim(user, side="both") # 将爬取内容两侧多余空格、制表符等删除
    
    # 爬取除博主名称外的其它元数据（“<div class="from">”），并清洗
    from <- web %>% html_nodes("div[class=from]") %>% html_text()
    from <- gsub("\\s+"," ",from)
    from <- str_trim(from, side="both")
    
    # 如无“展开”全文，则爬取节点“<p node-type="feed_list_content">”下的博文
    content_1 <- web %>% html_nodes("p[node-type=feed_list_content]") %>% html_text()
    content <- content_1[1]
    
    # 如有“展开”全文，则爬取节点“<p node-type="feed_list_content_full">”下的博文
    if (length(content) > 0) {
      if (any(grepl("展开c",str_c(content))==TRUE)){
        content <- web %>% html_nodes("p[node-type=feed_list_content_full]") %>% html_text()
        content <- gsub("收起d","",content)}
    }else{next}
    
    # 清洗爬取的博文
    content <- gsub("\\s+"," ",content)
    content <- str_trim(content, side="both")
    
    # 以XML格式将每条爬取的微博写入独立的文本文档
    weibo <- sprintf("<seg>\n<user>%s</user>\n<from>%s</from>\n<content>%s</content>\n</seg>\n",user,from,content) # 格式化输出XML格式
    num <- num + 1 # 为文本文档编号
    num_1 <- formatC(num, flag = '0', width = 3) # 为编号“Add Lead”，如将“1”转化为“001”
    fileout <- file(sprintf("WeiboCNTT%s.txt",num_1),"w") # 创建文本文档，并以如“WeiboCNTT001.txt”的形式命名
    print(weibo) # 输出爬取内容
    write(weibo,fileout) # 将爬取内容写入独立的文本文档
  }
}