# 将对应谷歌浏览器版本的“chromedriver.exe”放置于Python路径下（下载链接“https://registry.npmmirror.com/binary.html?path=chromedriver/”）
# 如无对应的版本（以上下载链接仅更新到114.0.5735.90版本），请打开谷歌浏览器，更新至最新版本（chrome-设置-关于chrome），并前往网站“https://googlechromelabs.github.io/chrome-for-testing/#stable”下载对应版本的chromedriver

from selenium import webdriver # “selenium”动态网页爬取库（模拟浏览器）
from bs4 import BeautifulSoup # HTML、XML等格式架构分析库
from time import sleep # 引入系统睡眠
import re # 正则表达式库
dic={} # 为检查是否重复，预先设置字典
num=0 # 为文本文档编号，预先设置“num”变量

# 基于“selenium”以谷歌浏览器访问“新华网”微博主页
driver=webdriver.Chrome(executable_path=r"C:\Users\sunmingchen\PycharmProjects\pythonProject\chromedriver.exe") # 这里是chromedriver的绝对路径
driver.get(url="https://m.weibo.cn/u/2810373291")

while True:

    sleep(3) # 设置3秒睡眠时间，防止微博反爬取

    # 获取新华网微博页当前源码
    page = BeautifulSoup(driver.page_source, "lxml")

    for e_1 in page.find_all("div", attrs={"class": "card-main"}): # 定位到每一条微博

        header=""
        content=""

        # 爬取博文元数据
        for e_2 in e_1.find_all("header"):
            header=e_2.text

        # 爬取博文内容（展开前）
        for e_2 in e_1.find_all("div", attrs={"class": "weibo-text"}):
            content = e_2.text

        match=re.findall("\S+",str(header))
        match_2=re.findall("\S+",str(content))

        if match:
            if match_2: # 判断爬取的博文元信息和内容是否为空
                if header in dic:
                    continue
                else: # 通过“header”判断是否重复爬取
                    dic[header]=1

                    # 如果博文未展开全文，访问存有博文全文的二级网页，爬取博文内容（展开后）
                    try:
                        if "...全文" in str(content):
                            e_3 = e_1.find_all("a")
                            url_2="https://m.weibo.cn{}".format(e_3[-1]["href"])
                            driver_2 = webdriver.Chrome(executable_path=r"C:\Users\sunmingchen\PycharmProjects\pythonProject\chromedriver.exe")
                            driver_2.get(url=url_2)
                            page_2=BeautifulSoup(driver_2.page_source, "lxml")
                            for e_3 in page_2.find_all("div", attrs={"class": "weibo-text"}):
                                content=e_3.text
                            driver_2.close()
                    except:
                        driver_2.close()

                    # 清洗博文元数据和内容，以XML格式，以“WeiboXH001.txt”的命名形式，存入独立的文本文档
                    header_2 = re.sub('\s+', ' ', str(header))
                    content_2 = re.sub('\s+', ' ', str(content))
                    weibo = "<seg>\n<meta>{}</meta>\n<content>{}</content>\n</seg>\n\n".format(header_2, content_2)

                    num += 1
                    num_1 = "{:0>3}".format(num)
                    fileout = open("WeiboXH{}.txt".format(num_1), "w", encoding="utf8")
                    fileout.write(weibo)
                    print(weibo)

                    sleep(1)

    # 自动向下滚动页面，加载更多微博
    driver.execute_script("window.scrollTo(0,document.body.scrollHeight);")